<?php

namespace Ems\Controllers;

use Ems\Services\ImportacaoAFDService;
use Ems\Util\ExpectedException;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\{ Message, Error };

class ImportacaoAFDController {
     /** @var ImportacaoAFDService */
    protected $importacaoAFDService;

    public function __construct(ImportacaoAFDService $importacaoAFDService) {
        $this->importacaoAFDService = $importacaoAFDService;
    }

    public function importacaoAFD(DTO\Request\Row $request, DTO\Response $response) { 
        try {
            $row = $request->getRow();

            if(empty($row['dataBase64AFD']))
                throw new \Exception('Arquivo AFD não localizado. Favor enviar o arquivo em formato base64.');

            $dataAFD = base64_decode($row['dataBase64AFD']);
            $mensagem = $this->importacaoAFDService->importacaoAFD($dataAFD);

            $response->addDataSet(new DataSet('importacaoAFD', $mensagem));

        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode(), $e->getTrace()));
        }
    }

    public function loginREP(DTO\Request\Row $request, DTO\Response $response) { 
        try {
            $row = $request->getRow();

            $arrResult = $this->importacaoAFDService->loginREP($row);

            $response->addDataSet(new DataSet('loginREP', $arrResult));

        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode(), $e->getTrace()));
        }
    }

}