<?php

namespace Folha\Logic\ControlePonto;
/**
 * Description of ControlePonto
 *
 * @author ingridmoreira
 */

use Setforms2\Runtime\Framework;
use Folha\Logic\ControlePonto\DateUtil;
use Folha\Logic\ControlePonto\FPA;

class ControlePonto {
    
    //Faz o ajuste do ponto levando em consideração o horário base e as tolerâncias deste
    public static function definePonto($bases, $pontos, $tolerancias){
        $tolerancias = explode(';', $tolerancias);
        sort($tolerancias);
        foreach($tolerancias as &$tolerancia){
            $tolerancia = explode('-', $tolerancia);
        }
        $bases  = explode(';',$bases);
        //$pontos = explode (';', $pontos);
        
        sort($bases);
        sort($pontos);
        
        //Ajusta o início do ponto
        for($i = 0; $i < count($pontos); $i++){
            if($i === 0){
                if($pontos[$i]< substr($pontos[$i],0,10).' '.$tolerancias[$i][0]){
                    $pontos[]         = substr($pontos[$i],0,10).' '.$bases[$i];
                    $pontos[]         = substr($pontos[$i],0,10).' '.$bases[$i];
                    $horaExtraInicial = true;
                }
                else{
                    $horaExtraInicial = false;
                }
                //tk_set_env_var('HORAEXTRAINICIAL',$horaExtraFinal);
            }
        }
         
        sort($pontos);
        
        //Ajusta o fim do ponto
        for($i = 0; $i < count($pontos); $i++){
            if($i === (count($pontos)-1)){
                if($pontos[$i] > substr($pontos[$i],0,10).' '.$tolerancias[count($tolerancias)-1][1]){
                    $pontos[]       = substr($pontos[$i],0,10).' '.$bases[count($tolerancias)-1];
                    $pontos[]       = substr($pontos[$i],0,10).' '.$bases[count($tolerancias)-1];
                    $horaExtraFinal = true;
                    
                }
                else{
                    $horaExtraFinal = false;
                }
                //tk_set_env_var('HORAEXTRAFINAL',$horaExtraFinal);
            }
        }
         
        sort($pontos);
        
        //Cria o array com os intervalos trabalhados
        $intervalosTrabalhados = array();
        for($i = 0; $i < count($pontos); $i++){
            if(fmod($i,2) == 0){
                $intervalosTrabalhados[] = array($pontos[$i], $pontos[$i+1]);
            }
        }
        
        //Cria o array com os intervalos de saídas
        $intervalosSaidas = array();
        for($i = 0; $i < count($pontos); $i++){
            if(fmod($i,2) != 0 && $i != (count($pontos)-1)){
                $intervalosSaidas[] = array($pontos[$i], $pontos[$i+1]);
            }
        }
        
        $ajustes = array(
                     'TOLERANCIA'        => $tolerancias,
                     'BASES'             => $bases,
                     'PONTOS'            => $pontos,
                     'INTERVALOSAIDAS'   => $intervalosSaidas,
                     'INTERVALOTRABALHO' => $intervalosTrabalhados,
                     'HORAEXTRAFINAL'    => $horaExtraFinal,
                     'HORAEXTRAINICIAL'  => $horaExtraInicial
                   );
        
        return $ajustes;
    }
    
    //Calcula a quantidade de horas trabalhadas normais(dentro do horário base)
    public static function calculaHorasTrabalhadasNormais($intervalosTrabalhados, $bases, $tolerancia, $tempoTotalTrabalho, $baseToleranciaInicio, $baseToleranciaFim){
                
        foreach($intervalosTrabalhados as $intervalo){
            if(
               ((!$baseToleranciaInicio && $intervalo[0] >= substr($intervalo[0],0,10).' '.$tolerancia['INICIO']) ||
                ( $baseToleranciaInicio && $intervalo[0] >= substr($intervalo[0],0,10).' '.$bases['INICIO'])) && 
               ((!$baseToleranciaFim && $intervalo[1]    <= substr($intervalo[1],0,10).' '.$tolerancia['FIM']) || 
                ( $baseToleranciaFim && $intervalo[1]    <= substr($intervalo[1],0,10).' '.$bases['FIM']))
              ){
                $primeiraData = DateUtil::getDataDeString($intervalo[0].':00',DateUtil::FORMATO_BRASILEIRO_DATAHORA );
                $segundaData  = DateUtil::getDataDeString($intervalo[1].':00', DateUtil::FORMATO_BRASILEIRO_DATAHORA);
                $tempo        = DateUtil::getIntervaloEmSegundos($primeiraData, $segundaData);
                $tempo        = $tempo/3600;
                $tempoTotal  += $tempo;
            }           
        }
        
        if($tempoTotal > $tempoTotalTrabalho){
            $horaExtra = $tempoTotal - $tempoTotalTrabalho;
            
            //tk_set_env_var('HORAEXTRA', $horaExtra);
            $tempoTotalTrabalho = DateUtil::getHoraStringDeFloat($tempoTotalTrabalho, true);
            return $tempoTotalTrabalho;
        }
        else{
            //tk_set_env_var('HORAEXTRA', '');
            $horaExtra = '';
        }
        $tempoTotal = DateUtil::getHoraStringDeFloat($tempoTotal, true);
        return array('TEMPOTOTALNORMAL' => $tempoTotal,
                     'HORAEXTRA'        => $horaExtra);
    }
    
    //Calcula a quantidade de horas de ausência intrajornada
    public static function calculaHorasSaidasIntermediarias($intervalosSaidas){
        foreach($intervalosSaidas as $intervalo){
            $primeiraData = DateUtil::getDataDeString($intervalo[0].':00',DateUtil::FORMATO_BRASILEIRO_DATAHORA );
            $segundaData  = DateUtil::getDataDeString($intervalo[1].':00', DateUtil::FORMATO_BRASILEIRO_DATAHORA);
            $tempo        = DateUtil::getIntervaloEmSegundos($primeiraData, $segundaData);
            $tempo        = $tempo/3600;
            $tempoTotal  += $tempo;
        }
        $tempoTotal = DateUtil::getHoraStringDeFloat($tempoTotal, true);
        return $tempoTotal;
    }
    
    //Calcula a quantidade de horas extras trabalhadas
    public static function calculaHorasExtras($intervalosTrabalhados, $bases, $tolerancia, $baseToleranciaInicio, $baseToleranciaFim, $horaExtra){
        $tempoTotal = $horaExtra;//tk_get_env_var('HORAEXTRA');
        foreach($intervalosTrabalhados as $intervalo){
            if(
               (!$baseToleranciaInicio && $intervalo[0] < substr($intervalo[0],0,10).' '.$tolerancia['INICIO']) || 
               ( $baseToleranciaInicio && $intervalo[0] < substr($intervalo[0],0,10).' '.$bases['INICIO']) ||     
               ( $baseToleranciaFim && $intervalo[1]    > substr($intervalo[1],0,10).' '.$bases['FIM']) ||
               (!$baseToleranciaFim && $intervalo[1]    > substr($intervalo[1],0,10).' '.$tolerancia['FIM']) 
              ){
                $primeiraData = DateUtil::getDataDeString($intervalo[0].':00',DateUtil::FORMATO_BRASILEIRO_DATAHORA );
                $segundaData  = DateUtil::getDataDeString($intervalo[1].':00', DateUtil::FORMATO_BRASILEIRO_DATAHORA);
                $tempo        = DateUtil::getIntervaloEmSegundos($primeiraData, $segundaData);
                $tempo        = $tempo/3600;
                $tempoTotal  += $tempo;
            }           
        }
        $tempoTotal = DateUtil::getHoraStringDeFloat($tempoTotal, true);
        return $tempoTotal;
    }
    
    public static function buscaDados(){
        $mapper = Framework::getInstance()->getCurrentMapper();
        if($mapper instanceof \Setforms2\Runtime\Mapper\Crud){
            $data = $mapper->getDatasource()->getData();
            $mapper->afterGetData($data);
            $data = $mapper->getDatasource()->getData();            
        }
        return $data;
    }
    
    
    /*
    * Valida parametrização de tempo de descanso diário
    */
    public static function validaDescansoDiario($data, $nrvinculom) {
        $nrorg = FPA::getNrorg();
        $paramorg = \Folha\Entities\GpeParamorg::findOneByNrorg(array($nrorg));
        $dataAnterior = DateUtil::getDataDeString(DateUtil::subtraiIntervalo(DateUtil::getDataDeString($data, DateUtil::FORMATO_BRASILEIRO), 1, DateUtil::DIA)->format(DateUtil::FORMATO_BRASILEIRO))->format(DateUtil::FORMATO_BRASILEIRO);
        
        $tempoDescansoDiario = $paramorg->getHrtempodescansodiario();

        $query = "
            SELECT DECODE(DIFF, null, 'false', TRUNC(DIFF) || ':' || LPAD(TRUNC(ROUND((DIFF - TRUNC(DIFF)) * 60)), 2, '0')) AS DIFF FROM (
            SELECT (TO_DATE(DTHRENTRADA) - TO_DATE(DTHRULTSAIDA)) * 24 AS DIFF FROM (
            SELECT (SELECT MIN(DTHRAJUSTADA) FROM GPE_MARCACAOPONTO
                WHERE NRORG      = :P_NRORG
                  AND NRVINCULOM = :P_NRVINCULOM
                  AND NRCOLETOR  = :P_NRCOLETOR_DIGITADA
                  AND (((IDDIAOCORRENCIA IS NULL OR IDDIAOCORRENCIA IN ('DA', 'DC', 'DS'))
                         AND TO_DATE(TO_CHAR(DTHRAJUSTADA,'DD/MM/YYYY')) BETWEEN TO_DATE(:P_DTPONTO,'DD/MM/YYYY')
                         AND TO_DATE(:P_DTPONTO,'DD/MM/YYYY'))
                       OR  (IDDIAOCORRENCIA = 'FA' AND TRUNC(DTHRAJUSTADA) = TO_DATE(:P_DTPONTO,'DD/MM/YYYY')+1 ) 
                       OR  (IDDIAOCORRENCIA = 'FS' AND TRUNC(DTHRAJUSTADA) = TO_DATE(:P_DTPONTO,'DD/MM/YYYY')-1) 
                       OR  (IDDIAOCORRENCIA = 'FC' AND TRUNC(DTHRAJUSTADA) = TO_DATE(:P_DTPONTO,'DD/MM/YYYY')))) DTHRENTRADA,
              (SELECT MAX(DTHRAJUSTADA) FROM GPE_MARCACAOPONTO
                WHERE NRORG      = :P_NRORG
                  AND NRVINCULOM = :P_NRVINCULOM
                  AND NRCOLETOR  = :P_NRCOLETOR_DIGITADA
                  AND (((IDDIAOCORRENCIA IS NULL OR IDDIAOCORRENCIA IN ('DA', 'DC', 'DS'))
                         AND TO_DATE(TO_CHAR(DTHRAJUSTADA,'DD/MM/YYYY')) BETWEEN TO_DATE(:P_DTPONTOANTERIOR,'DD/MM/YYYY')
                         AND TO_DATE(:P_DTPONTOANTERIOR,'DD/MM/YYYY'))
                       OR  (IDDIAOCORRENCIA = 'FA' AND TRUNC(DTHRAJUSTADA) = TO_DATE(:P_DTPONTOANTERIOR,'DD/MM/YYYY')+1 ) 
                       OR  (IDDIAOCORRENCIA = 'FS' AND TRUNC(DTHRAJUSTADA) = TO_DATE(:P_DTPONTOANTERIOR,'DD/MM/YYYY')-1) 
                       OR  (IDDIAOCORRENCIA = 'FC' AND TRUNC(DTHRAJUSTADA) = TO_DATE(:P_DTPONTOANTERIOR,'DD/MM/YYYY')))) DTHRULTSAIDA
              FROM DUAL))
        ";        

        $params = array(
            "P_NRORG"              => $nrorg,
            "P_NRVINCULOM"         => $nrvinculom,
            "P_DTPONTO"            => $data,
            "P_DTPONTOANTERIOR"    => $dataAnterior,
            "P_NRCOLETOR_DIGITADA" => 24 // coletor de marcação digitada
        );

        $macacoes = \Setforms2\Shared\Registry::getEntityManagerConnection()->fetchAssoc($query, $params);

        if ($macacoes["DIFF"] != 'false') {
            if (DateUtil::getHoraFloatDeString($macacoes["DIFF"]) < DateUtil::getHoraFloatDeString($tempoDescansoDiario)) {        
                throw new \Exception("Operação bloqueada! <br> Descanso entre jornadas de '". $macacoes["DIFF"] ."' é inferior à '". $tempoDescansoDiario ."', entre os dias ". $dataAnterior ." e ". $data ."<br>");
            }
        }
    }

    /*
    * Valida existência de ocorrências pendentes para o dia
    */
    public static function validaOcorrenciasPendentes($data, $nrvinculom) {
        $nrorg = FPA::getNrorg();

        $query = "
            SELECT
                COUNT(1) AS COUNT_OCORRENCIAS_PENDENTES
              FROM PTO_PROGOCORRENCIA PROG
             WHERE PROG.NRORG                = :P_NRORG
               AND IDATIVO                   = 'S'
               AND PROG.NRVINCULOM           = :P_NRVINCULOM
               AND PROG.DTINICIOPROGOCOR     = TO_DATE(:P_DTAPURACAOPONTO, 'DD/MM/YYYY')
               AND PROG.IDPROGOCORCONFIRMADA = 'P'
        ";

        $params = array(
            "P_NRORG"           => $nrorg,
            "P_NRVINCULOM"      => $nrvinculom,
            "P_DTAPURACAOPONTO" => $data
        );

        $return = \Setforms2\Shared\Registry::getEntityManagerConnection()->fetchAssoc($query, $params);

        if (isset($return['COUNT_OCORRENCIAS_PENDENTES'])) {
            $count = $return['COUNT_OCORRENCIAS_PENDENTES'];
            if (intval($count) > 0) {
                throw new \Exception("Operação bloqueada! <br> Existem ocorrências pendentes para o dia ". $data ."<br>");
            }
        }
    }

    public static function validaOcorrenciasRejeitadas($data, $nrvinculom) {
        $nrorg = FPA::getNrorg();

        $query = "
            SELECT
                COUNT(1) AS COUNT_OCORRENCIAS_REJEITADAS
            FROM 
                PTO_PROGOCORRENCIA PROG
            WHERE 
                PROG.NRORG                = :P_NRORG
                AND IDATIVO                   = 'S'
                AND PROG.NRVINCULOM           = :P_NRVINCULOM
                AND PROG.DTINICIOPROGOCOR     = TO_DATE(:P_DTAPURACAOPONTO, 'DD/MM/YYYY')
                AND PROG.IDPROGOCORCONFIRMADA = 'N'
        ";

        $params = array(
            "P_NRORG"           => $nrorg,
            "P_NRVINCULOM"      => $nrvinculom,
            "P_DTAPURACAOPONTO" => $data
        );

        $return = \Setforms2\Shared\Registry::getEntityManagerConnection()->fetchAssoc($query, $params);

        if (isset($return['COUNT_OCORRENCIAS_REJEITADAS'])) {
            $count = $return['COUNT_OCORRENCIAS_REJEITADAS'];
            if (intval($count) > 0) {
                throw new \Exception("Operação bloqueada! <br> Existem ocorrências recusadas para o dia ". $data ."<br>");
            }
        }
    }
}
