<?php

namespace HCM\FPA\ObrigacaoLegal\CNAB\Mentore\registro;

use HCM\Util\Messages;
use HCM\Util\Repositories;
use HCM\Util\DateUtil;
use HCM\Util\FPA;
use HCM\Util\TkDI;
use HCM\Util\MsgCalculo;
use HCM\FPA\Registro\RegistroCNAB;
use HCM\FPA\ObrigacaoLegal\CNAB\Mentore\CNABMentore;

class Registro31CNABMentore extends RegistroCNAB{

    const REGISTRO_31 = '31';
    const LOTE_SERVICO_REGISTRO_9 = '9999';

    public function geraRegistro31(){
        //Bloco 1 | 01-02 | Identificador registro header
        $this->atribuiDado('31', 2);
        
        // Bloco 2 | 03-10 | Qtde total de registros enviados para deposito
        //gerado na função modificaLinhasConsolidacaoMentore no arquivo CNABMentore
        
        // Bloco 3 | 11-20 | Valor total de registros enviados para deposito
        $this->atribuiDado('0000000000', 10, parent::CARACTER_ZERO, parent::PREENCHE_ESQUERDA);
        
        //Bloco 4 | 21-28 | Numero da linha
        $this->atribuiDado(1, 8, parent::CARACTER_ZERO, parent::PREENCHE_ESQUERDA);
    }
}