<?php
namespace HCM\FPA\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use HCM\Util\Repositories;

class BloqueioEventoVinculoRepository {
    
    protected  $connection;
    public function __construct(Connection $connection, EntityManager $entityManager) {
        $this->connection = $connection;
        $this->entityManager = $entityManager;
    }
    
    public function retornaEventosBloqueados ($nrorg, $nrorg_padrao, $dtmescompetenc, $nreventom, $tipovinc) {
        
        $sql = "
SELECT
  EVB.*,
  EVHB.NMEVENTOH AS NMEVENTOMBLOQ,
  EVHD.NMEVENTOH AS NMEVENTOMPARA,
  TVH.NMTIPOVINCULOH
FROM
  FPA_EVENTOBLOQUEADO EVB
  LEFT JOIN FPA_EVENTOH EVHB ON EVHB.NRORG IN ( EVB.NRORG, :P_NRORG_PADRAO )
                              AND EVHB.NREVENTOM = EVB.NREVENTOMBLOQ
                            AND EVHB.DTMESCOMPETENC = (SELECT
                                                         MAX(EVEH.DTMESCOMPETENC)
                                                       FROM
                                                         FPA_EVENTOH EVEH
                                                       WHERE
                                                         EVEH.NRORG = EVHB.NRORG
                                                         AND EVEH.NREVENTOM = EVHB.NREVENTOM
                                                         AND EVEH.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  
  LEFT JOIN FPA_EVENTOH EVHD ON EVHD.NRORG IN ( EVB.NRORG, :P_NRORG_PADRAO )
                              AND EVHD.NREVENTOM = EVB.NREVENTOMPARA
                            AND EVHD.DTMESCOMPETENC = (SELECT
                                                         MAX(EVTH.DTMESCOMPETENC)
                                                       FROM
                                                         FPA_EVENTOH EVTH
                                                       WHERE
                                                         EVTH.NRORG = EVHD.NRORG
                                                         AND EVTH.NREVENTOM = EVHD.NREVENTOM
                                                         AND EVTH.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
                                                    
  LEFT JOIN GPE_TIPOVINCULOH TVH ON TVH.NRORG IN ( EVB.NRORG, :P_NRORG_PADRAO )
                                  AND TVH.NRTIPOVINCULOM = EVB.NRTIPOVINCULOM
                                                    
WHERE
  EVB.IDATIVO = 'S'
  AND (EVB.NRORG = :P_NRORG OR EVB.NRORG = :P_NRORG_PADRAO)
  AND NREVENTOMBLOQ = :P_NREVENTOM
  AND EVB.NRTIPOVINCULOM = :P_NRTIPOVINCULOM
        ";
        
        $params = array(
            'P_NRORG'            => $nrorg,
            'P_NRORG_PADRAO'     => $nrorg_padrao,
            'P_DTMESCOMPETENC'   => $dtmescompetenc,
            'P_NREVENTOM'        => $nreventom,
            'P_NRTIPOVINCULOM'   => $tipovinc
        );
        
        $result = $this->connection->fetchAll($sql, $params);
        
        if (count($result) === 0)
            return null;
        else
            return $result[0];
    }
}