<?php

namespace Vab\Controllers;

use Vab\Services\CalculoValeTransporteService;
use Util\Environment;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\{ Error, Message };
use Zeedhi\Framework\DTO\Response\Notification;


class CalculoValeTransporteController {
    /** @var CalculoBeneficioService */
    protected $calculoValeTransporteService;

    public function __construct(
        Environment $environment,
        CalculoValeTransporteService $calculoValeTransporteService
    ) {
        $this->environment                      = $environment;
        $this->calculoValeTransporteService     = $calculoValeTransporteService;
    }
    
    public function calcular(Request\Row $request, Response $response)
    {
        try {
            $row = $request->getRow();
            
            $result = $this->calculoValeTransporteService->calcularValeTransporte($row);
            $response->addDataSet(new DataSet('calcular', [$result]));
        } catch (\Exception $e) {
            $variables = null;
            if ($e instanceof CustomException) {
                $variables = $e->getVariables();
            }
            $response->addMessage(new Response\Message($e->getMessage(), Response\Message::TYPE_ERROR, null, $variables));
            
            $response->addMessage(new Response\Message($e->getMessage(), Response\Message::TYPE_ERROR, null, $variables));
        }
    }
    
}